﻿// <auto-generated />

using System;
using System.Linq;
using System.Text;
using System.Collections;
using System.Reflection;
using System.Collections.Generic;
using Microsoft.Xrm.Sdk;
using Microsoft.Xrm.Sdk.Query;
using Microsoft.Crm.Sdk.Messages;
using Microsoft.Xrm.Sdk.Messages;
using Microsoft.Xrm.Sdk.Metadata;
namespace ProxyClassNameSpace
{
    public abstract partial class BaseProxyClass
    {
        protected BaseProxyClass(Entity Original)
        {
            if (string.IsNullOrEmpty(Original.LogicalName)) { throw new Exception("Please specify the 'LogicalName' on the entity when using a proxy class."); }
            string EntityName = GetLogicalName(this.GetType());
            if (EntityName != Original.LogicalName) { throw new Exception("Please make sure that the entity logical name matches that of the proxy class you are creating."); }
            _entity = Original;
        }
        public static bool ReturnDatesInLocalTime = false;
        private readonly Entity _entity;
        public Entity Entity { get { return _entity; } }
        public Guid Id { get { return this.Entity.Id; } set { this.Entity.Id = value; } }
        public string LogicalName { get { return this.Entity.LogicalName; } set { this.Entity.LogicalName = value; } }
        public Guid Create(IOrganizationService Service)
        {
            this.Id = Service.Create(this.Entity);
            mChangedValues.Clear();
            return this.Id;
        }
        /// <summary>
        /// Checks to see if the underlying entity contains the specified attribute
        /// </summary>
        /// <param name="AttributeName">Name of attribute to check</param>
        /// <returns></returns>
        public bool Contains(string AttributeName)
        {
            return this.Entity.Contains(AttributeName);
        }
        public void Delete(IOrganizationService Service)
        {
            Service.Delete(this.Entity.LogicalName, this.Entity.Id);
        }
        public void Update(IOrganizationService Service)
        {
            if (mChangedValues.Count > 0)
            {
                Service.Update(GetChangedEntity());
            }
            mChangedValues.Clear();
        }
        public Entity GetChangedEntity()
        {
            Entity entity = new Entity(this.LogicalName);
            entity.Id = this.Id;
            foreach (string attributeName in mChangedValues.Keys)
            {
                entity.Attributes[attributeName] = this.Entity.Attributes[attributeName];
            }
            return entity;
        }
        public void Save(IOrganizationService Service)
        {
            if (this.Entity.Id != Guid.Empty) { this.Update(Service); }
            else { this.Create(Service); }
        }
        public static BaseProxyClass CreateProxyType(Entity entity)
        {
            if (ProxyTypes.ContainsValue(entity.LogicalName))
            {
                Type ProxyType = (from ProxyTypeTemp in ProxyTypes.Keys where ProxyTypes[ProxyTypeTemp] == entity.LogicalName select ProxyTypeTemp).FirstOrDefault();
                ConstructorInfo ConstructorTemp = ProxyType.GetConstructor(new Type[] { typeof(Entity) });
                return (BaseProxyClass)ConstructorTemp.Invoke(new object[] { entity });
            }
            else
            {
                throw new Exception("The proxy class for type '" + entity.LogicalName + "' has not been registered.");
            }
        }
        private static Dictionary<Type, string> ProxyTypes = new Dictionary<Type, string>();
        public static void RegsterProxyType(Type ProxyType, string LogicalName)
        {
            if (!ProxyTypes.ContainsKey(ProxyType)) { ProxyTypes.Add(ProxyType, LogicalName); }
        }
        public static string GetLogicalName<T>() where T : BaseProxyClass
        {
            return GetLogicalName(typeof(T));
        }
        public static string GetLogicalName(Type type)
        {
            if (!ProxyTypes.ContainsKey(type))
            {
                //This forces the static constructor to be called and register the name
                ConstructorInfo InfoTemp = type.GetConstructor(new Type[] { });
                InfoTemp.Invoke(new object[] { });
            }
            return ProxyTypes[type];
        }
        public EntityReference ToEntityReference()
        {
            if (this.Id != Guid.Empty) { return new EntityReference(this.LogicalName, this.Id); }
            return null;
        }
        public static implicit operator EntityReference(BaseProxyClass Proxy)
        {
            if (Proxy != null) { return Proxy.ToEntityReference(); }
            return null;
        }
        public static implicit operator Entity(BaseProxyClass Proxy)
        {
            if (Proxy != null) { return Proxy.Entity; }
            return null;
        }
        public T GetPropertyValue<T>(string Name)
        {
            if (this.Entity.Contains(Name))
            {
                T Value = (T)this.Entity.Attributes[Name];
                if ((typeof(T) == typeof(DateTime) || typeof(T) == typeof(DateTime?)) && ReturnDatesInLocalTime && Value != null)
                {
                    Value = (T)(Object)((DateTime)(Object)Value).ToLocalTime();
                }
                return Value;
            }
            return default(T);
        }
        //dictionary of values that have changed along with the original value
        Dictionary<string, object> mChangedValues = new Dictionary<string, object>();
        AttributeEqualityComparer mEqualityComparer = new AttributeEqualityComparer();
        public void SetPropertyValue<T>(string Name, T Value)
        {
            if (mChangedValues.ContainsKey(Name))
            {
                object OriginalValue = mChangedValues[Name];
                object CurrentValue = this.Entity.Contains(Name) ? (object)this.GetPropertyValue<T>(Name) : null;
                if (!mEqualityComparer.Equals(CurrentValue, Value))
                {
                    if (mEqualityComparer.Equals(OriginalValue, Value)) { mChangedValues.Remove(Name); }
                }
            }
            else
            {
                object CurrentValue = this.Entity.Contains(Name) ? (object)this.GetPropertyValue<T>(Name) : null;
                if (!mEqualityComparer.Equals(CurrentValue, Value)) { mChangedValues.Add(Name, CurrentValue); }
            }
            this.Entity.Attributes[Name] = Value;
        }
        public void SetPropertyValue(string Name, string Value, int MaxLength)
        {
            eTextOptions TextOptions = GetTextOptions(Name);
            if (TextOptions != eTextOptions.Ignore && !string.IsNullOrEmpty(Value) && Value.Length > MaxLength)
            {
                if (TextOptions == eTextOptions.Truncate) { Value = Value.Substring(0, MaxLength); }
                else { throw new Exception(string.Format(GetErrorString(Name, eErrorType.Text), Name, Value, Value.Length, MaxLength)); }
            }
            SetPropertyValue<string>(Name, Value);
        }
        public void SetPropertyValue(string Name, int? Value, int MinValue, int MaxValue)
        {
            eNumberOptions NumberOptions = GetNumberOptions(Name);
            if (NumberOptions != eNumberOptions.Ignore && (Value < MinValue || Value > MaxValue))
            {
                bool ThrowError = false;
                if (NumberOptions == eNumberOptions.CorrectMinAndMax) { Value = (Value < MinValue) ? MinValue : MaxValue; }
                else if (NumberOptions == eNumberOptions.CorrectMinIgnoreMax) { Value = (Value < MinValue) ? MinValue : Value; }
                else if (NumberOptions == eNumberOptions.CorrectMinThrowMax && Value < MinValue) { Value = MinValue; }
                else if (NumberOptions == eNumberOptions.CorrectMaxIgnoreMin) { Value = (Value > MaxValue) ? MaxValue : Value; }
                else if (NumberOptions == eNumberOptions.CorrectMaxThrowMin && Value > MaxValue) { Value = MaxValue; }
                else { ThrowError = true; }
                if (ThrowError) { throw new Exception(string.Format(GetErrorString(Name, eErrorType.Number), Name, Value, MinValue, MaxValue)); }
            }
            SetPropertyValue<int?>(Name, Value);
        }
        public void SetPropertyValue(string Name, decimal? Value, decimal MinValue, decimal MaxValue)
        {
            eNumberOptions NumberOptions = GetNumberOptions(Name);
            if (NumberOptions != eNumberOptions.Ignore && (Value < MinValue || Value > MaxValue))
            {
                bool ThrowError = false;
                if (NumberOptions == eNumberOptions.CorrectMinAndMax) { Value = (Value < MinValue) ? MinValue : MaxValue; }
                else if (NumberOptions == eNumberOptions.CorrectMinIgnoreMax) { Value = (Value < MinValue) ? MinValue : Value; }
                else if (NumberOptions == eNumberOptions.CorrectMinThrowMax && Value < MinValue) { Value = MinValue; }
                else if (NumberOptions == eNumberOptions.CorrectMaxIgnoreMin) { Value = (Value > MaxValue) ? MaxValue : Value; }
                else if (NumberOptions == eNumberOptions.CorrectMaxThrowMin && Value > MaxValue) { Value = MaxValue; }
                else { ThrowError = true; }
                if (ThrowError) { throw new Exception(string.Format(GetErrorString(Name, eErrorType.Number), Name, Value, MinValue, MaxValue)); }
            }
            SetPropertyValue<decimal?>(Name, Value);
        }
        public void SetPropertyValue(string Name, double? Value, double MinValue, double MaxValue)
        {
            eNumberOptions NumberOptions = GetNumberOptions(Name);
            if (NumberOptions != eNumberOptions.Ignore && (Value < MinValue || Value > MaxValue))
            {
                bool ThrowError = false;
                if (NumberOptions == eNumberOptions.CorrectMinAndMax) { Value = (Value < MinValue) ? MinValue : MaxValue; }
                else if (NumberOptions == eNumberOptions.CorrectMinIgnoreMax) { Value = (Value < MinValue) ? MinValue : Value; }
                else if (NumberOptions == eNumberOptions.CorrectMinThrowMax && Value < MinValue) { Value = MinValue; }
                else if (NumberOptions == eNumberOptions.CorrectMaxIgnoreMin) { Value = (Value > MaxValue) ? MaxValue : Value; }
                else if (NumberOptions == eNumberOptions.CorrectMaxThrowMin && Value > MaxValue) { Value = MaxValue; }
                else { ThrowError = true; }
                if (ThrowError) { throw new Exception(string.Format(GetErrorString(Name, eErrorType.Number), Name, Value, MinValue, MaxValue)); }
            }
            SetPropertyValue<double?>(Name, Value);
        }
        public void SetPropertyValue(string Name, Money Value, decimal MinValue, decimal MaxValue)
        {
            eNumberOptions NumberOptions = GetNumberOptions(Name);
            if (Value != null && NumberOptions != eNumberOptions.Ignore && (Value.Value < MinValue || Value.Value > MaxValue))
            {
                bool ThrowError = false;
                if (NumberOptions == eNumberOptions.CorrectMinAndMax) { Value.Value = (Value.Value < MinValue) ? MinValue : MaxValue; }
                else if (NumberOptions == eNumberOptions.CorrectMinIgnoreMax) { Value.Value = (Value.Value < MinValue) ? MinValue : Value.Value; }
                else if (NumberOptions == eNumberOptions.CorrectMinThrowMax && Value.Value < MinValue) { Value.Value = MinValue; }
                else if (NumberOptions == eNumberOptions.CorrectMaxIgnoreMin) { Value.Value = (Value.Value > MaxValue) ? MaxValue : Value.Value; }
                else if (NumberOptions == eNumberOptions.CorrectMaxThrowMin && Value.Value > MaxValue) { Value.Value = MaxValue; }
                else { ThrowError = true; }
                if (ThrowError) { throw new Exception(string.Format(GetErrorString(Name, eErrorType.Number), Name, Value.Value, MinValue, MaxValue)); }
            }
            SetPropertyValue<Money>(Name, Value);
        }
        protected abstract eTextOptions GetTextOptions(string LogicalName);
        protected abstract string GetErrorString(string AttributeName, eErrorType DefaultErrorType);
        protected abstract eNumberOptions GetNumberOptions(string LogicalName);
        public bool IsDirty
        {
            get { return this.mChangedValues.Count > 0; }
        }
        public static List<T> GetRelatedOneToManyEntities<T>(IOrganizationService Service, Guid RelatedId, string LogicalName, string AttributeName, params string[] Columns) where T : BaseProxyClass
        {
            return GetRelatedOneToManyEntities(Service, RelatedId, LogicalName, AttributeName, Columns).ToProxies<T>();
        }
        public static List<T> GetRelatedOneToManyEntities<T>(IOrganizationService Service, Guid RelatedId, string LogicalName, string AttributeName, ColumnSet Columns) where T : BaseProxyClass
        {
            return GetRelatedOneToManyEntities(Service, RelatedId, LogicalName, AttributeName, Columns).ToProxies<T>();
        }
        public static List<Entity> GetRelatedOneToManyEntities(IOrganizationService Service, Guid RelatedId, string LogicalName, string AttributeName, params string[] Columns)
        {
            ColumnSet ColumnSet = (Columns.Length == 0) ? new ColumnSet(true) : new ColumnSet(Columns);
            return GetRelatedOneToManyEntities(Service, RelatedId, LogicalName, AttributeName, ColumnSet);
        }
        public static List<Entity> GetRelatedOneToManyEntities(IOrganizationService Service, Guid RelatedId, string LogicalName, string AttributeName, ColumnSet Columns)
        {
            return Service.RetrieveMultiple(LogicalName, new ConditionExpression(AttributeName, ConditionOperator.Equal, RelatedId), Columns).Entities.ToList();
        }
        public static List<T> GetRelatedManyToManyEntities<T>(IOrganizationService service, BaseProxyClass proxy, string linkFromEntityTypeName, string linkFromAttributeName, string linkToEntityTypeName, string linkToAttributeName, string intermediateEntityName, string intermediateFromAttributeName, string intermediateToAttributeName, params string[] columns) where T:BaseProxyClass
        {
            return GetRelatedManyToManyEntities(service, proxy, linkFromEntityTypeName, linkFromAttributeName, linkToEntityTypeName, linkToAttributeName, intermediateEntityName, intermediateFromAttributeName, intermediateToAttributeName, columns).ToProxies<T>();
        }
        public static List<T> GetRelatedManyToManyEntities<T>(IOrganizationService service, BaseProxyClass proxy, string linkFromEntityTypeName, string linkFromAttributeName, string linkToEntityTypeName, string linkToAttributeName, string intermediateEntityName, string intermediateFromAttributeName, string intermediateToAttributeName, ColumnSet columns) where T:BaseProxyClass
        {
            return GetRelatedManyToManyEntities(service, proxy, linkFromEntityTypeName, linkFromAttributeName, linkToEntityTypeName, linkToAttributeName, intermediateEntityName, intermediateFromAttributeName, intermediateToAttributeName, columns).ToProxies<T>();
        }
        public static List<Entity> GetRelatedManyToManyEntities(IOrganizationService service, BaseProxyClass proxy, string linkFromEntityTypeName, string linkFromAttributeName, string linkToEntityTypeName, string linkToAttributeName, string intermediateEntityName, string intermediateFromAttributeName, string intermediateToAttributeName, params string[] columns)
        {
            var columnSet = (columns.Length == 0) ? new ColumnSet(true) : new ColumnSet(columns);
            return GetRelatedManyToManyEntities(service, proxy, linkFromEntityTypeName, linkFromAttributeName, linkToEntityTypeName, linkToAttributeName, intermediateEntityName, intermediateFromAttributeName, intermediateToAttributeName, columnSet);
        }
        public static List<Entity> GetRelatedManyToManyEntities(IOrganizationService service, BaseProxyClass proxy, string linkFromEntityTypeName, string linkFromAttributeName, string linkToEntityTypeName, string linkToAttributeName, string intermediateEntityName, string intermediateFromAttributeName, string intermediateToAttributeName, ColumnSet columns)
        {
            var query = new QueryExpression()
            {
                EntityName = linkToEntityTypeName,
                ColumnSet = columns,
                LinkEntities = {
                    new LinkEntity(){
                        LinkFromAttributeName = linkToAttributeName,
                        LinkFromEntityName = linkToEntityTypeName,
                        LinkToAttributeName = intermediateToAttributeName,
                        LinkToEntityName = intermediateEntityName,
                        LinkEntities = {
                            new LinkEntity(){
                                LinkFromAttributeName = intermediateFromAttributeName,
                                LinkFromEntityName = intermediateEntityName,
                                LinkToAttributeName = linkFromAttributeName,
                                LinkToEntityName = linkFromEntityTypeName,
                                LinkCriteria = new FilterExpression(){
                                    Conditions = {
                                        new ConditionExpression(linkFromAttributeName, ConditionOperator.Equal, new object[]{ proxy.Id })
                                    }
                                }
                            }
                        }
                    }
                }
            };

            return service.RetrieveMultiple(query).Entities.ToList();
        }
        public static List<Entity> GetRelatedManyToManyEntities(IOrganizationService Service, BaseProxyClass Proxy, string LinkFromAttributeName, string RelatedEntityName, string LinkToAttributeName, string IntermediateEntityName, ColumnSet Columns)
        {
            ConditionExpression Condition = new ConditionExpression()
            {
                AttributeName = LinkFromAttributeName,
                Operator = ConditionOperator.Equal,
                Values = { Proxy.Id }
            };

            LinkEntity Link1 = new LinkEntity()
            {
                LinkFromEntityName = RelatedEntityName,
                LinkFromAttributeName = LinkToAttributeName,
                LinkToEntityName = IntermediateEntityName,
                LinkToAttributeName = LinkToAttributeName,
                LinkCriteria = new FilterExpression() { Conditions = { Condition } }
            };

            LinkEntity Link2 = new LinkEntity()
            {
                LinkFromEntityName = IntermediateEntityName,
                LinkFromAttributeName = LinkFromAttributeName,
                LinkToEntityName = Proxy.LogicalName,
                LinkToAttributeName = LinkFromAttributeName,
                LinkCriteria = new FilterExpression() { Conditions = { Condition } }
            };
            Link1.LinkEntities.Add(Link2);

            QueryExpression Query = new QueryExpression()
            {
                EntityName = RelatedEntityName,
                ColumnSet = Columns,
                LinkEntities = { Link1 }
            };

            return Service.RetrieveMultiple(Query).Entities.ToList();
        }
        private class AttributeEqualityComparer : IEqualityComparer
        {
            public bool Equals(object x, object y)
            {
                if ((x == null || (x.GetType() == typeof(string) && string.IsNullOrEmpty(x as string))) && (y == null || (y.GetType() == typeof(string) && string.IsNullOrEmpty(y as string))))
                {
                    return true;
                }
                else
                {
                    if (x == null && y == null) { return true; }
                    else if (x == null && y != null) { return false; }
                    else if (x != null && y == null) { return false; }
                    else if (x.GetType() == y.GetType())
                    {
                        if (x.GetType() == typeof(OptionSetValue)) { return ((OptionSetValue)x).Value == ((OptionSetValue)y).Value; }
                        else if (x.GetType() == typeof(BooleanManagedProperty)) { return ((BooleanManagedProperty)x).Value == ((BooleanManagedProperty)y).Value; }
                        else if (x.GetType() == typeof(EntityReference))
                        {
                            if (((EntityReference)x).LogicalName == ((EntityReference)y).LogicalName) { return ((EntityReference)x).Id == ((EntityReference)y).Id; }
                            else { return false; }
                        }
                        else if (x.GetType() == typeof(Money)) { return (((Money)x).Value == ((Money)y).Value); }
                        else if (x.GetType() == typeof(DateTime) || x.GetType() == typeof(DateTime?))
                        {
                            //Compare only down to the second since CRM only tracks down to the second
                            return Math.Abs(((DateTime)x - (DateTime)y).TotalSeconds) < 1;
                        }
                        else { return x.Equals(y); }
                    }
                    else { return false; }
                }
            }
            public int GetHashCode(object obj)
            {
                return obj.GetHashCode();
            }
        }
        public enum eTextOptions
        {
            /// <summary>Ignore and let CRM handle any issues with the value</summary>
            Ignore,
            /// <summary>If the length is greater than the max length, truncate the value to the max length</summary>
            Truncate,
            /// <summary>Throw an error if the length of the value is greater than the max length</summary>
            ThrowError
        }
        public enum eNumberOptions
        {
            /// <summary>Ignore and let CRM handle any issues with the value.</summary>
            Ignore,
            /// <summary>If the value is less than the min value set the value as the min value.<para>Let CRM handle any issues with the max value.</para></summary>
            CorrectMinIgnoreMax,
            /// <summary>If the value is less than the min value set the value as the min value.<para>Throw an error if the value is greater than the max value.</para></summary>
            CorrectMinThrowMax,
            /// <summary>If the value is greater than the max value set the value as the max value.<para>Let CRM handle any issues with the min value.</para></summary>
            CorrectMaxIgnoreMin,
            /// <summary>If the value is greater than the max value set the value as the max value.<para>Throw an error if the value is less than the min value.</para></summary>
            CorrectMaxThrowMin,
            /// <summary>If the value is less than the min value set the value as the min value.<para>If the value is greater than the max value set the value as the max value.</para></summary>
            CorrectMinAndMax,
            /// <summary>Throw an error if the value is less than the min or greater than the max</summary>
            ThrowError
        }
        public enum eErrorType
        {
            Text,
            Number
        }
    }

    public static partial class ExtensionMethods
    {
        public static void Create(this IOrganizationService Service, BaseProxyClass Proxy)
        {
            Guid EntityId = Service.Create(Proxy.Entity);
            Proxy.Id = EntityId;
        }
        public static void Update(this IOrganizationService Service, BaseProxyClass Proxy)
        {
            Proxy.Update(Service);
        }
        public static void Delete(this IOrganizationService Service, BaseProxyClass Proxy)
        {
            Service.Delete(Proxy.LogicalName, Proxy.Id);
        }
        public static void SetState(this IOrganizationService Service, BaseProxyClass Proxy, int State, int Status)
        {
            Service.SetState(Proxy, new OptionSetValue(State), new OptionSetValue(Status));
        }
        public static void SetState(this IOrganizationService Service, BaseProxyClass Proxy, OptionSetValue State, OptionSetValue Status)
        {
            SetStateRequest Request = new SetStateRequest() { EntityMoniker = Proxy, State = State, Status = Status };
            Service.Execute(Request);
        }
        public static T ToProxy<T>(this EntityReference reference) where T : BaseProxyClass
        {
            if (reference == null) { return null; }
            return reference.ToEntity().ToProxy<T>();
        }
        public static Entity ToEntity(this EntityReference reference)
        {
            if (reference == null) { return null; }
            return new Entity() { LogicalName = reference.LogicalName, Id = reference.Id };
        }
        public static T ToProxy<T>(this Entity entity) where T : BaseProxyClass
        {
            if (entity != null)
            {
                ConstructorInfo Constructor = typeof(T).GetConstructor(new Type[] { typeof(Entity) });
                return entity.ToProxy<T>(Constructor);
            }
            return null;
        }
        private static T ToProxy<T>(this Entity entity, ConstructorInfo construcor) where T : BaseProxyClass
        {
            return construcor.Invoke(new object[] { entity }) as T;
        }
        public static AttributeMetadata GetAttributeMetadata(this IOrganizationService Service, string EntityLogicalName, string AttributeLogicalName)
        {
            RetrieveAttributeRequest Request = new RetrieveAttributeRequest() { EntityLogicalName = EntityLogicalName, LogicalName = AttributeLogicalName };
            return (Service.Execute(Request) as RetrieveAttributeResponse).AttributeMetadata;
        }
        public static OptionMetadata GetOptionMetadata(this OptionSetValue Value, IOrganizationService Service, BaseProxyClass Entity, string AttributeLogicalName)
        {
            AttributeMetadata AttributeMeta = Service.GetAttributeMetadata(Entity.LogicalName, AttributeLogicalName);
            if (AttributeMeta is EnumAttributeMetadata)
            {
                return ((EnumAttributeMetadata)AttributeMeta).GetOptionMetadata(Value.Value);
            }
            else { throw new Exception("The attribute is not an Enum type attribute"); }
        }
        public static OptionMetadata GetOptionMetadata(this EnumAttributeMetadata EnumMeta, int Value)
        {
            return (from Meta in EnumMeta.OptionSet.Options where Meta.Value == Value select Meta).FirstOrDefault();
        }
        public static string GetOptionSetText(this EnumAttributeMetadata EnumMeta, int Value)
        {
            return EnumMeta.GetOptionMetadata(Value).GetOptionSetText();
        }
        public static string GetOptionSetText(this OptionSetValue Value, IOrganizationService Service, BaseProxyClass Entity, string AttributeName)
        {
            OptionMetadata OptionMeta = GetOptionMetadata(Value, Service, Entity, AttributeName);
            return OptionMeta.GetOptionSetText();
        }
        public static string GetOptionSetText(this OptionMetadata OptionMeta)
        {
            if (OptionMeta != null && OptionMeta.Label != null && OptionMeta.Label.UserLocalizedLabel != null) { return OptionMeta.Label.UserLocalizedLabel.Label; }
            return string.Empty;
        }
        public static List<T> RetrieveProxies<T>(this IOrganizationService Service, ConditionExpression expression, ColumnSet columns) where T : BaseProxyClass
        {
            FilterExpression FilterExpression = new FilterExpression();
            FilterExpression.AddCondition(expression);
            return Service.RetrieveProxies<T>(FilterExpression, columns);
        }
        public static List<T> RetrieveProxies<T>(this IOrganizationService Service, FilterExpression expression, ColumnSet columns) where T : BaseProxyClass
        {
            QueryExpression Query = new QueryExpression(BaseProxyClass.GetLogicalName<T>()) { ColumnSet = columns, Criteria = expression };
            return Service.RetrieveProxies<T>(Query);
        }
        public static List<T> RetrieveProxies<T>(this IOrganizationService Service, params string[] Columns) where T : BaseProxyClass
        {
            return Service.RetrieveProxies<T>(GetColumnSet(Columns));
        }
        public static List<T> RetrieveProxies<T>(this IOrganizationService Service, ColumnSet Columns) where T : BaseProxyClass
        {
            QueryExpression Query = new QueryExpression(BaseProxyClass.GetLogicalName<T>()) { ColumnSet = Columns };
            return Service.RetrieveMultipleAllPages(Query).ToProxies<T>();
        }
        public static List<T> RetrieveProxies<T>(this IOrganizationService Service, QueryExpression query) where T : BaseProxyClass
        {
            EntityCollection Entities = Service.RetrieveMultipleAllPages(query);
            return Entities.ToProxies<T>();
        }
        public static List<T> ToProxies<T>(this EntityCollection Entities) where T : BaseProxyClass
        {
            return Entities.Entities.ToProxies<T>();
        }
        public static List<T> ToProxies<T>(this IEnumerable<Entity> Entities) where T : BaseProxyClass
        {
            ConstructorInfo Constructor = typeof(T).GetConstructor(new Type[] { typeof(Entity) });
            return (from EntityTemp in Entities select EntityTemp.ToProxy<T>(Constructor)).ToList();
        }
        public static T RetrieveProxy<T>(this EntityReference Entity, IOrganizationService Service, params string[] Columns) where T : BaseProxyClass
        {
            return Service.RetrieveProxy<T>(Entity.Id, Columns);
        }
        public static T RetrieveProxy<T>(this EntityReference Entity, IOrganizationService Service, ColumnSet Columns) where T : BaseProxyClass
        {
            return Service.RetrieveProxy<T>(Entity.Id, Columns);
        }
        public static T RetrieveProxy<T>(this IOrganizationService Service, Guid Id, params string[] Columns) where T : BaseProxyClass
        {
            string entityName = BaseProxyClass.GetLogicalName<T>();
            return RetrieveEntity(new EntityReference(entityName, Id), Service, Columns).ToProxy<T>();
        }
        public static T RetrieveProxy<T>(this IOrganizationService Service, Guid Id, ColumnSet columns) where T : BaseProxyClass
        {
            string entityName = BaseProxyClass.GetLogicalName<T>();
            return RetrieveEntity(new EntityReference(entityName, Id), Service, columns).ToProxy<T>();
        }
        public static T FindProxy<T>(this IOrganizationService Service, string PropertyName, object Value, params string[] Columns) where T : BaseProxyClass
        {
            return Service.FindProxy<T>(PropertyName, Value, GetColumnSet(Columns));
        }
        public static T FindProxy<T>(this IOrganizationService Service, string PropertyName, object Value, ColumnSet Columns) where T : BaseProxyClass
        {
            return Service.FindProxies<T>(PropertyName, Value, Columns).FirstOrDefault();
        }
        public static T FindProxy<T>(this IOrganizationService Service, string PropertyName, ConditionOperator Operator, object Value, params string[] Columns) where T : BaseProxyClass
        {
            return Service.FindProxy<T>(PropertyName, Operator, Value, GetColumnSet(Columns));
        }
        public static T FindProxy<T>(this IOrganizationService Service, string PropertyName, ConditionOperator Operator, object Value, ColumnSet Columns) where T : BaseProxyClass
        {
            return Service.FindProxies<T>(PropertyName, Operator, Value, Columns).FirstOrDefault();
        }
        public static List<T> FindProxies<T>(this IOrganizationService Service, string PropertyName, object Value, params string[] Columns) where T : BaseProxyClass
        {
            return Service.FindProxies<T>(PropertyName, Value, GetColumnSet(Columns));
        }
        public static List<T> FindProxies<T>(this IOrganizationService Service, string PropertyName, object Value, ColumnSet Columns) where T : BaseProxyClass
        {
            return Service.FindProxies<T>(PropertyName, ConditionOperator.Equal, Value, Columns);
        }
        public static List<T> FindProxies<T>(this IOrganizationService Service, string PropertyName, ConditionOperator Operator, object Value, params string[] Columns) where T : BaseProxyClass
        {
            return Service.FindProxies<T>(PropertyName, Operator, Value, GetColumnSet(Columns));
        }
        public static List<T> FindProxies<T>(this IOrganizationService Service, string PropertyName, ConditionOperator Operator, object Value, ColumnSet Columns) where T : BaseProxyClass
        {
            ConditionExpression PropertyCondition = Value != null ? new ConditionExpression(PropertyName, Operator, Value) : new ConditionExpression(PropertyName, Operator);
            return Service.RetrieveProxies<T>(PropertyCondition, Columns);
        }
        internal static ColumnSet GetColumnSet(params string[] Columns)
        {
            ColumnSet ColumnSet = new ColumnSet(Columns);
            if (ColumnSet.Columns.Count == 0) { ColumnSet = new ColumnSet(true); }
            return ColumnSet;
        }
        public static Entity RetrieveEntity(this EntityReference Entity, IOrganizationService Service, params string[] Columns)
        {
            return Entity.RetrieveEntity(Service, GetColumnSet(Columns));
        }
        public static Entity RetrieveEntity(this EntityReference Entity, IOrganizationService Service, ColumnSet Columns)
        {
            if (Columns == null) { Columns = new ColumnSet(true); }
            return Service.Retrieve(Entity.LogicalName, Entity.Id, Columns);
        }
        public static EntityCollection RetrieveMultiple(this IOrganizationService Service, string LogicalName, ConditionExpression Condition, params string[] Columns)
        {
            return Service.RetrieveMultiple(LogicalName, Condition, GetColumnSet(Columns));
        }
        public static EntityCollection RetrieveMultiple(this IOrganizationService Service, string LogicalName, ConditionExpression Condition, ColumnSet Columns)
        {
            QueryExpression Query = new QueryExpression(LogicalName) { ColumnSet = Columns };
            Query.Criteria.AddCondition(Condition);
            return Service.RetrieveMultipleAllPages(Query);
        }
        public static bool RetrieveAllPages = true;
        public static EntityCollection RetrieveMultipleAllPages(this IOrganizationService Service, QueryExpression Query)
        {
            EntityCollection Results = Service.RetrieveMultiple(Query);
            while (Results.MoreRecords && RetrieveAllPages)
            {
                IList<Entity> CurrentResults = Results.Entities;
                Query.PageInfo.PagingCookie = Results.PagingCookie;
                Query.PageInfo.PageNumber += 1;
                Results = Service.RetrieveMultiple(Query);
                Results.Entities.AddRange(CurrentResults);
            }
            return Results;
        }
        public static void RelateEntities(this IOrganizationService Service, EntityReference Target, string IntermediateEntityName, IList<Entity> Entities)
        {
            Service.RelateEntities(Target, IntermediateEntityName, Entities.ToArray());
        }
        public static void RelateEntities(this IOrganizationService Service, EntityReference Target, string IntermediateEntityName, params Entity[] Entities)
        {
            IList<EntityReference> References = (from EntityTemp in Entities select EntityTemp.ToEntityReference()).ToList();
            Service.RelateEntities(Target, IntermediateEntityName, References);
        }
        public static void RelateEntities(this IOrganizationService Service, EntityReference Target, string IntermediateEntityName, IList<EntityReference> Entities)
        {
            Service.RelateEntities(Target, IntermediateEntityName, Entities.ToArray());
        }
        public static void RelateEntities(this IOrganizationService Service, EntityReference Target, string IntermediateEntityName, params EntityReference[] Entities)
        {
            AssociateRequest Request = new AssociateRequest()
            {
                Relationship = new Relationship(IntermediateEntityName),
                Target = Target,
            };
            Request.RelatedEntities = new EntityReferenceCollection(Entities);
            Service.Execute(Request);
        }
        public static void UnRelateEntities(this IOrganizationService Service, EntityReference Target, string IntermediateEntityName, IList<Entity> Entities)
        {
            Service.UnRelateEntities(Target, IntermediateEntityName, Entities.ToArray());
        }
        public static void UnRelateEntities(this IOrganizationService Service, EntityReference Target, string IntermediateEntityName, params Entity[] Entities)
        {
            IList<EntityReference> References = (from EntityTemp in Entities select EntityTemp.ToEntityReference()).ToList();
            Service.UnRelateEntities(Target, IntermediateEntityName, References);
        }
        public static void UnRelateEntities(this IOrganizationService Service, EntityReference Target, string IntermediateEntityName, IList<EntityReference> Entities)
        {
            Service.UnRelateEntities(Target, IntermediateEntityName, Entities.ToArray());
        }
        public static void UnRelateEntities(this IOrganizationService Service, EntityReference Target, string IntermediateEntityName, params EntityReference[] Entities)
        {
            DisassociateRequest Request = new DisassociateRequest()
            {
                Target = Target,
                Relationship = new Relationship(IntermediateEntityName)
            };
            Request.RelatedEntities = new EntityReferenceCollection(Entities);
            Service.Execute(Request);
        }
        public static void Add(this List<OrganizationRequest> Requests, BaseProxyClass Proxy)
        {
            OrganizationRequest RequestTemp = GetOrganizationRequest(Proxy);
            if (RequestTemp != null) { Requests.Add(RequestTemp); }
        }
        public static void Add(this OrganizationRequestCollection Collection, BaseProxyClass Proxy)
        {
            OrganizationRequest RequestTemp = GetOrganizationRequest(Proxy);
            if (RequestTemp != null) { Collection.Add(RequestTemp); }
        }
        public static OrganizationRequest GetOrganizationRequest(BaseProxyClass Proxy)
        {
            if (Proxy.Entity.Id != Guid.Empty && Proxy.IsDirty)
            {
                return new UpdateRequest() { Target = Proxy.GetChangedEntity() };
            }
            else if (Proxy.Entity.Id == Guid.Empty)
            {
                return new CreateRequest() { Target = Proxy };
            }
            return null;
        }
        public static void GrantAccess(this IAccessControlledEntity Entity, IOrganizationService Service, EntityReference Principal, AccessRights AccessMask)
        {
            GrantAccessRequest Request = new GrantAccessRequest() { PrincipalAccess = new PrincipalAccess() { Principal = Principal, AccessMask = AccessMask }, Target = (EntityReference)(object)Entity };
            Service.Execute(Request);
        }
        public static void ModifyAccess(this IAccessControlledEntity Entity, IOrganizationService Service, EntityReference Principal, AccessRights AccessMask)
        {
            ModifyAccessRequest Request = new ModifyAccessRequest() { PrincipalAccess = new PrincipalAccess() { Principal = Principal, AccessMask = AccessMask }, Target = (EntityReference)(object)Entity };
            Service.Execute(Request);
        }
        public static void RevokeAccess(this IAccessControlledEntity Entity, IOrganizationService Service, EntityReference Revokee)
        {
            RevokeAccessRequest Request = new RevokeAccessRequest() { Revokee = Revokee, Target = (EntityReference)(object)Entity };
            Service.Execute(Request);
        }
        private static Dictionary<string, Dictionary<Guid, Entity>> mCachedEntities = new Dictionary<string, Dictionary<Guid, Entity>>();
        public static void ClearCache(string EntityLogicalName = null)
        {
            lock (mCachedEntities)
            {
                if (!string.IsNullOrEmpty(EntityLogicalName))
                {
                    if (mCachedEntities.ContainsKey(EntityLogicalName)) { mCachedEntities[EntityLogicalName] = new Dictionary<Guid, Entity>(); }
                }
                else { mCachedEntities.Clear(); }
            }
        }
        public static void ClearCache(this IOrganizationService Service, string EntityLogicalName = null)
        {
            ClearCache(EntityLogicalName);
        }
        public static Entity RetrieveCachedEntityById(this IOrganizationService Service, string EntityLogicalName, Guid Id, ColumnSet Columns)
        {
            lock (mCachedEntities)
            {
                Entity CachedEntity = GetEntityFromCache(EntityLogicalName, Id);
                if (CachedEntity == null)
                {
                    CachedEntity = Service.Retrieve(EntityLogicalName, Id, Columns);
                    AddEntityToCache(CachedEntity);
                }
                return CachedEntity;
            }
        }
        public static Entity GetEntityFromCache(this IOrganizationService Service, string EntityLogicalName, Guid Id)
        {
            return GetEntityFromCache(EntityLogicalName, Id);
        }
        public static Entity GetEntityFromCache(string EntityLogicalName, Guid Id)
        {
            lock (mCachedEntities)
            {
                Entity CachedEntity = null;
                Dictionary<Guid, Entity> CachedEntities = GetEntitiesFromCache(EntityLogicalName);
                CachedEntities.TryGetValue(Id, out CachedEntity);
                return CachedEntity;
            }
        }
        public static Dictionary<Guid, Entity> GetEntitiesFromCache(this IOrganizationService Service, string EntityLogicalName)
        {
            return GetEntitiesFromCache(EntityLogicalName);
        }
        public static Dictionary<Guid, Entity> GetEntitiesFromCache(string EntityLogicalName)
        {
            lock (mCachedEntities)
            {
                Dictionary<Guid, Entity> CachedEntities = new Dictionary<Guid, Entity>();
                mCachedEntities.TryGetValue(EntityLogicalName, out CachedEntities);
                return CachedEntities != null ? CachedEntities : new Dictionary<Guid, Entity>();
            }
        }
        public static void AddEntitiesToCache<T>(this IOrganizationService Service, ICollection<T> Entities) where T : BaseProxyClass
        {
            foreach (T Item in Entities) { AddEntityToCache(Item.Entity); }
        }
        public static void AddEntitiesToCache(this IOrganizationService Service, ICollection<Entity> Entities)
        {
            AddEntitiesToCache(Entities);
        }
        public static void AddEntitiesToCache(ICollection<Entity> Entities)
        {
            lock (mCachedEntities)
            {
                foreach (Entity Item in Entities)
                {
                    AddEntityToCache(Item);
                }
            }
        }
        public static void AddEntityToCache(this IOrganizationService Service, Entity Item)
        {
            AddEntityToCache(Item);
        }
        public static void AddEntityToCache(Entity Item)
        {
            lock (mCachedEntities)
            {
                if (!mCachedEntities.ContainsKey(Item.LogicalName))
                {
                    mCachedEntities.Add(Item.LogicalName, new Dictionary<Guid, Entity> { });
                }
                if (!mCachedEntities[Item.LogicalName].ContainsKey(Item.Id))
                {
                    mCachedEntities[Item.LogicalName].Add(Item.Id, Item);
                }
            }
        }
        public static T RetrieveCachedProxy<T>(this IOrganizationService Service, EntityReference Entity) where T : BaseProxyClass
        {
            return RetrieveCachedProxy<T>(Service, Entity, new ColumnSet(true));
        }
        public static T RetrieveCachedProxy<T>(this IOrganizationService Service, EntityReference Entity, params string[] Columns) where T : BaseProxyClass
        {
            return RetrieveCachedProxy<T>(Service, Entity, GetColumnSet(Columns));
        }
        public static T RetrieveCachedProxy<T>(this IOrganizationService Service, EntityReference Entity, ColumnSet Columns) where T : BaseProxyClass
        {
            return RetrieveCachedEntityById(Service, Entity.LogicalName, Entity.Id, Columns).ToProxy<T>();
        }
        public static T RetrieveCachedProxy<T>(this EntityReference Entity, IOrganizationService Service) where T : BaseProxyClass
        {
            return RetrieveCachedProxy<T>(Entity, Service, new ColumnSet(true));
        }
        public static T RetrieveCachedProxy<T>(this EntityReference Entity, IOrganizationService Service, params string[] Columns) where T : BaseProxyClass
        {
            return RetrieveCachedProxy<T>(Entity, Service, GetColumnSet(Columns));
        }
        public static T RetrieveCachedProxy<T>(this EntityReference Entity, IOrganizationService Service, ColumnSet Columns) where T : BaseProxyClass
        {
            return Service.RetrieveCachedProxy<T>(Entity, Columns);
        }
        public static EntityMetadata GetEntityMetadata(this IOrganizationService Service, string LogicalName, EntityFilters Filters)
        {
            RetrieveEntityRequest Request = new RetrieveEntityRequest() { LogicalName = LogicalName, EntityFilters = Filters };
            return ((RetrieveEntityResponse)Service.Execute(Request)).EntityMetadata;
        }
    }
    public interface IAccessControlledEntity { }
}