﻿// <auto-generated />

using System;
using System.Linq;
using System.Collections.Generic;
using Microsoft.Xrm.Sdk;
using Microsoft.Xrm.Sdk.Query;
using Microsoft.Crm.Sdk.Messages;
using Microsoft.Xrm.Sdk.Messages;
using Microsoft.Xrm.Sdk.Metadata;
namespace ProxyClassNameSpace
{
    public class ProxyClassTemplateName : BaseProxyClass
    {
        static ProxyClassTemplateName()
        {
            BaseProxyClass.RegsterProxyType(typeof(ProxyClassTemplateName), "LogicalNameString");
            mTextOptions = new Dictionary<string, eTextOptions>();
            mNumberOptions = new Dictionary<string, eNumberOptions>();
            mErrorStrings = new Dictionary<string, string>();
            TextError = "The value for attribute '{0}' cannot be longer than {3} characters. The length of the value is {2} characters.";
            NumberError = "The value for attribute '{0}' must be between {2} and {3}. The value is {1}";
        }
        public ProxyClassTemplateName() : base(new Entity("LogicalNameString")) { }
        public ProxyClassTemplateName(Entity Original) : base(Original) { }
        public static string GetLogicalName() { return BaseProxyClass.GetLogicalName<ProxyClassTemplateName>(); }
        /// <summary>
        /// Action to perform when the string value is greater than the allowed length.
        /// <para>This is the default for any string attribute in this Entity</para>
        /// </summary>
        public static eTextOptions TextOptions { get; set; }
        private static Dictionary<string, eTextOptions> mTextOptions;
        /// <summary>
        /// Use this to set an action and error string when a value is greater than the allowed length
        /// </summary>
        /// <param name="LogicalName">Name of Attribute</param>
        /// <param name="Options">Action to perform when the value is greater than the allowed length</param>
        /// <param name="ErrorString">Optional: Error to throw if the eTextOptions == ThrowError
        /// <para>If nothing is specified then the 'TextError' string is used.</para>
        /// <para>You may use the following parameters:</para>
        /// <para>{0} = Attribute Logical Name</para>
        /// <para>{1} = Value</para>
        /// <para>{2} = Length</para>
        /// <para>{3} = Max Length</para>
        /// </param>
        public static void SetTextOptions(string LogicalName, eTextOptions Options, string ErrorString = null)
        {
            if (mTextOptions.ContainsKey(LogicalName)) { mTextOptions[LogicalName] = Options; }
            else { mTextOptions.Add(LogicalName, Options); }
            if (!string.IsNullOrEmpty(ErrorString))
            {
                if (mErrorStrings.ContainsKey(LogicalName)) { mErrorStrings[LogicalName] = ErrorString; }
                else { mErrorStrings.Add(LogicalName, ErrorString); }
            }
            else if (mErrorStrings.ContainsKey(LogicalName)) { mErrorStrings.Remove(LogicalName); }
        }
        protected override eTextOptions GetTextOptions(string LogicalName)
        {
            if (mTextOptions.ContainsKey(LogicalName)) { return mTextOptions[LogicalName]; }
            return TextOptions;
        }
        /// <summary>
        /// Action to perform when the number value is greater or less than the allowed value.
        /// <para>This is the default for any int, decimal, double, or money attribute in this Entity</para>
        /// </summary>
        public static eNumberOptions NumberOptions { get; set; }
        private static Dictionary<string, eNumberOptions> mNumberOptions;
        /// <summary>
        /// Use this to set an action and error string when a value is greater or less than the allowed value
        /// </summary>
        /// <param name="LogicalName">Name of Attribute</param>
        /// <param name="Options">Action to perform when the value is greater or less than the allowed value</param>
        /// <param name="ErrorString">Optional: Error to throw if the eNumberOptions == ThrowError
        /// <para>If nothing is specified then the 'NumberError' string is used.</para>
        /// <para>You may use the following parameters:</para>
        /// <para>{0} = Attribute Logical Name</para>
        /// <para>{1} = Value</para>
        /// <para>{2} = Min Value</para>
        /// <para>{3} = Max Value</para>
        /// </param>
        public static void SetNumberOptions(string LogicalName, eNumberOptions Options, string ErrorString = null)
        {
            if (mNumberOptions.ContainsKey(LogicalName)) { mNumberOptions[LogicalName] = Options; }
            else { mNumberOptions.Add(LogicalName, Options); }
            if (!string.IsNullOrEmpty(ErrorString))
            {
                if (mErrorStrings.ContainsKey(LogicalName)) { mErrorStrings[LogicalName] = ErrorString; }
                else { mErrorStrings.Add(LogicalName, ErrorString); }
            }
            else if (mErrorStrings.ContainsKey(LogicalName)) { mErrorStrings.Remove(LogicalName); }
        }
        protected override eNumberOptions GetNumberOptions(string LogicalName)
        {
            if (mNumberOptions.ContainsKey(LogicalName)) { return mNumberOptions[LogicalName]; }
            return NumberOptions;
        }
        private static Dictionary<string, string> mErrorStrings;
        protected override string GetErrorString(string AttributeName, BaseProxyClass.eErrorType DefaultErrorType)
        {
            if (mErrorStrings.ContainsKey(AttributeName))
            {
                return mErrorStrings[AttributeName];
            }
            return DefaultErrorType == BaseProxyClass.eErrorType.Text ? TextError : NumberError;
        }
        /// <summary>
        /// <para>Default error string is: The value for attribute '{0}' cannot be longer than {3} characters. The length of the value is {2} characters.</para>
        /// <para>You may use the following parameters</para>
        /// <para>{0} = Attribute Name</para>
        /// <para>{1} = Value</para>
        /// <para>{2} = Length</para>
        /// <para>{3} = Max Length</para>
        /// </summary>
        public static string TextError { get; set; }
        /// <summary>
        /// <para>Default error string is: The value for attribute '{0}' must be between {2} and {3}. The value is {1}.</para>
        /// <para>You may use the following parameters</para>
        /// <para>{0} = Attribute Name</para>
        /// <para>{1} = Value</para>
        /// <para>{2} = Min Value</para>
        /// <para>{3} = Max Value</para>
        /// </summary>
        public static string NumberError { get; set; }

        public string Properties;

        public string OneToManyMethods;

        public string ManyToManyMethods;

        public string EntitySpecificMethods;

        public string Enums;

        public string PropertyNamesClass;

    }
}
