﻿
' <auto-generated />

Imports System.Linq
Imports System.Collections.Generic
Imports Microsoft.Xrm.Sdk
Imports Microsoft.Xrm.Sdk.Query
Imports Microsoft.Crm.Sdk.Messages
Imports Microsoft.Xrm.Sdk.Messages
Imports Microsoft.Xrm.Sdk.Metadata
Namespace ProxyClassNameSpace
    Public Class ProxyClassTemplateName
        Inherits BaseProxyClass
        Shared Sub New()
            BaseProxyClass.RegsterProxyType(GetType(ProxyClassTemplateName), "LogicalNameString")
            mTextOptions = New Dictionary(Of String, eTextOptions)()
            mNumberOptions = New Dictionary(Of String, eNumberOptions)()
            mErrorStrings = New Dictionary(Of String, String)()
            TextError = "The value for attribute '{0}' cannot be longer than {3} characters. The length of the value is {2} characters."
            NumberError = "The value for attribute '{0}' must be between {2} and {3}. The value is {1}"
        End Sub
        Public Sub New()
            MyBase.New(New Entity("LogicalNameString"))
        End Sub
        Public Sub New(Original As Entity)
            MyBase.New(Original)
        End Sub
        Public Shared Function GetLogicalName() As String
            Return BaseProxyClass.GetLogicalName(Of ProxyClassTemplateName)()
        End Function

        ''' <summary>
        ''' Action to perform when the string value is greater than the allowed length.
        ''' <para>This is the default for any string attribute in this Entity</para>
        ''' </summary>
        Public Shared Property TextOptions() As eTextOptions
            Get
                Return m_TextOptions
            End Get
            Set(value As eTextOptions)
                m_TextOptions = value
            End Set
        End Property
        Private Shared m_TextOptions As eTextOptions
        Private Shared mTextOptions As Dictionary(Of String, eTextOptions)
        ''' <summary>
        ''' Use this to set an action and error string when a value is greater than the allowed length
        ''' </summary>
        ''' <param name="LogicalName">Name of Attribute</param>
        ''' <param name="Options">Action to perform when the value is greater than the allowed length</param>
        ''' <param name="ErrorString">Optional: Error to throw if the eTextOptions == ThrowError
        ''' <para>If nothing is specified then the 'TextError' string is used.</para>
        ''' <para>You may use the following parameters:</para>
        ''' <para>{0} = Attribute Logical Name</para>
        ''' <para>{1} = Value</para>
        ''' <para>{2} = Length</para>
        ''' <para>{3} = Max Length</para>
        ''' </param>
        Public Shared Sub SetTextOptions(LogicalName As String, Options As eTextOptions, Optional ErrorString As String = Nothing)
            If mTextOptions.ContainsKey(LogicalName) Then
                mTextOptions(LogicalName) = Options
            Else
                mTextOptions.Add(LogicalName, Options)
            End If
            If Not String.IsNullOrEmpty(ErrorString) Then
                If mErrorStrings.ContainsKey(LogicalName) Then
                    mErrorStrings(LogicalName) = ErrorString
                Else
                    mErrorStrings.Add(LogicalName, ErrorString)
                End If
            ElseIf mErrorStrings.ContainsKey(LogicalName) Then
                mErrorStrings.Remove(LogicalName)
            End If
        End Sub
        Protected Overrides Function GetTextOptions(LogicalName As String) As eTextOptions
            If mTextOptions.ContainsKey(LogicalName) Then
                Return mTextOptions(LogicalName)
            End If
            Return TextOptions
        End Function
        ''' <summary>
        ''' Action to perform when the number value is greater or less than the allowed value.
        ''' <para>This is the default for any int, decimal, double, or money attribute in this Entity</para>
        ''' </summary>
        Public Shared Property NumberOptions() As eNumberOptions
            Get
                Return m_NumberOptions
            End Get
            Set(value As eNumberOptions)
                m_NumberOptions = value
            End Set
        End Property
        Private Shared m_NumberOptions As eNumberOptions
        Private Shared mNumberOptions As Dictionary(Of String, eNumberOptions)
        ''' <summary>
        ''' Use this to set an action and error string when a value is greater or less than the allowed value
        ''' </summary>
        ''' <param name="LogicalName">Name of Attribute</param>
        ''' <param name="Options">Action to perform when the value is greater or less than the allowed value</param>
        ''' <param name="ErrorString">Optional: Error to throw if the eNumberOptions == ThrowError
        ''' <para>If nothing is specified then the 'NumberError' string is used.</para>
        ''' <para>You may use the following parameters:</para>
        ''' <para>{0} = Attribute Logical Name</para>
        ''' <para>{1} = Value</para>
        ''' <para>{2} = Min Value</para>
        ''' <para>{3} = Max Value</para>
        ''' </param>
        Public Shared Sub SetNumberOptions(LogicalName As String, Options As eNumberOptions, Optional ErrorString As String = Nothing)
            If mNumberOptions.ContainsKey(LogicalName) Then
                mNumberOptions(LogicalName) = Options
            Else
                mNumberOptions.Add(LogicalName, Options)
            End If
            If Not String.IsNullOrEmpty(ErrorString) Then
                If mErrorStrings.ContainsKey(LogicalName) Then
                    mErrorStrings(LogicalName) = ErrorString
                Else
                    mErrorStrings.Add(LogicalName, ErrorString)
                End If
            ElseIf mErrorStrings.ContainsKey(LogicalName) Then
                mErrorStrings.Remove(LogicalName)
            End If
        End Sub
        Protected Overrides Function GetNumberOptions(LogicalName As String) As eNumberOptions
            If mNumberOptions.ContainsKey(LogicalName) Then
                Return mNumberOptions(LogicalName)
            End If
            Return NumberOptions
        End Function
        Private Shared mErrorStrings As Dictionary(Of String, String)
        Protected Overrides Function GetErrorString(AttributeName As String, DefaultErrorType As BaseProxyClass.eErrorType) As String
            If mErrorStrings.ContainsKey(AttributeName) Then
                Return mErrorStrings(AttributeName)
            End If
            Return If(DefaultErrorType = BaseProxyClass.eErrorType.Text, TextError, NumberError)
        End Function
        ''' <summary>
        ''' <para>Default error string is: The value for attribute '{0}' cannot be longer than {3} characters. The length of the value is {2} characters.</para>
        ''' <para>You may use the following parameters</para>
        ''' <para>{0} = Attribute Name</para>
        ''' <para>{1} = Value</para>
        ''' <para>{2} = Length</para>
        ''' <para>{3} = Max Length</para>
        ''' </summary>
        Public Shared Property TextError() As String
            Get
                Return m_TextError
            End Get
            Set(value As String)
                m_TextError = value
            End Set
        End Property
        Private Shared m_TextError As String
        ''' <summary>
        ''' <para>Default error string is: The value for attribute '{0}' must be between {2} and {3}. The value is {1}.</para>
        ''' <para>You may use the following parameters</para>
        ''' <para>{0} = Attribute Name</para>
        ''' <para>{1} = Value</para>
        ''' <para>{2} = Min Value</para>
        ''' <para>{3} = Max Value</para>
        ''' </summary>
        Public Shared Property NumberError() As String
            Get
                Return m_NumberError
            End Get
            Set(value As String)
                m_NumberError = value
            End Set
        End Property
        Private Shared m_NumberError As String

        Public Properties As String

        Public OneToManyMethods As String

        Public ManyToManyMethods As String

        Public EntitySpecificMethods As String

        Public Enums As String

        Public PropertyNamesClass As String

    End Class
End Namespace